/*

 # Editor : Holiday
 # Date   : 20160117
 # Product: NFC Module for Arduino
 # SKU    : DFR0231
 
 Product Link ：
 https://item.taobao.com/item.htm?spm=a1z10.3-c.w4002-3141887416.9.fNDjXd&id=18882986346
 
 PN532 reads the tag by Leonardo

*/

#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#define print1Byte(args) Serial1.write(args)
#define print1lnByte(args)  Serial1.write(args),Serial1.println()
#else
#include "WProgram.h"
#define print1Byte(args) Serial1.print(args,BYTE)
#define print1lnByte(args)  Serial1.println(args,BYTE)
#endif

unsigned char receive_ACK[30];

void setup()
{
  Serial.begin(9600);
  Serial1.begin(115200);

  wakeUp();
  delay(1000);
  readAck(15);
  for(int i=0;i<15;i++)  Serial.print(receive_ACK[i]);
  Serial.println();

}

void loop()
{ 
  //wakeUp();
  getUID();
  readAck(25);  delay(100);
  for(int i=0;i<25;i++)  {Serial.print(receive_ACK[i],HEX);Serial.print(" ");}
  Serial.println();

  delay(400);
}

void wakeUp()
{
  const unsigned char wake[24]={
  0x55, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x03, 0xfd, 0xd4, 0x14, 0x01, 0x17, 0x00};//wake up NFC module
  for(int i=0;i<24;i++) //send command
  {
    UART1_Send_Byte(wake[i]);
  }
}

void getUID()
{
  const unsigned char cmdUID[11]={ 0x00, 0x00, 0xFF, 0x04, 0xFC, 0xD4, 0x4A, 0x01, 0x00, 0xE1, 0x00};
  for(int i=0;i<11;i++)  
  {
    UART1_Send_Byte(cmdUID[i]);
  }
}

void readAck(int x)
{
  unsigned char i;
  for(i=0;i<x;i++) {
    receive_ACK[i]= Serial1.read();
  }
}

void UART1_Send_Byte(unsigned char command_data)
{//send byte to device
  print1Byte(command_data);
#if defined(ARDUINO) && ARDUINO >= 100
  Serial1.flush();// complete the transmission of outgoing serial data 
#endif
} 

